Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.net.ssl
Class KeyManagerFactory

    java.lang.Object
      javax.net.ssl.KeyManagerFactory

    public class KeyManagerFactory

extends Object

This class acts as a factory for key managers based on a source of key material. Each key manager manages a specific type of key material for use by secure sockets. The key material is based on a KeyStore and/or provider specific sources.

Since:
  1.4
See Also:
  `KeyManager`

Constructor Summary
`protected` | `KeyManagerFactory(KeyManagerFactorySpi factorySpi, Provider provider, String algorithm)` Creates a KeyManagerFactory object.

Method Summary
`String` | `getAlgorithm()` Returns the algorithm name of this `KeyManagerFactory` object.
`static String` | `getDefaultAlgorithm()` Obtains the default KeyManagerFactory algorithm name.
`static KeyManagerFactory` | `getInstance(String algorithm)` Generates a `KeyManagerFactory` object that implements the specified key management algorithm.
`static KeyManagerFactory` | `getInstance(String algorithm, Provider provider)` Generates a `KeyManagerFactory` object for the specified key management algorithm from the specified provider.
`static KeyManagerFactory` | `getInstance(String algorithm, String provider)` Generates a `KeyManagerFactory` object for the specified key management algorithm from the specified provider.
`KeyManager[]` | `getKeyManagers()` Returns one key manager for each type of key material.
`Provider` | `getProvider()` Returns the provider of this `KeyManagerFactory` object.
`void` | `init(KeyStore ks, char[] password)` Initializes this factory with a source of key material.
`void` | `init(ManagerFactoryParameters spec)` Initializes this factory with a source of provider-specific key material.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### KeyManagerFactory

    protected KeyManagerFactory(KeyManagerFactorySpi factorySpi,
                                Provider provider,
                                String algorithm)

  Creates a KeyManagerFactory object.

  Parameters:
    `factorySpi` - the delegate
    `provider` - the provider
    `algorithm` - the algorithm

Method Detail

### getDefaultAlgorithm

    public static final String getDefaultAlgorithm()

  Obtains the default KeyManagerFactory algorithm name.

  The default algorithm can be changed at runtime by setting the value of the "ssl.KeyManagerFactory.algorithm" security property (set in the Java security properties file or by calling `Security.setProperty(java.lang.String, java.lang.String)`) to the desired algorithm name.

  Returns:
    the default algorithm name as specified in the Java security properties, or an implementation-specific default if no such property exists.
  See Also:
    `Security.setProperty(java.lang.String, java.lang.String)`

### getAlgorithm

    public final String getAlgorithm()

  Returns the algorithm name of this `KeyManagerFactory` object.

  This is the same name that was specified in one of the `getInstance` calls that created this `KeyManagerFactory` object.

  Returns:
    the algorithm name of this `KeyManagerFactory` object.

### getInstance

    public static final KeyManagerFactory getInstance(String algorithm)
                                               throws NoSuchAlgorithmException

  Generates a `KeyManagerFactory` object that implements the specified key management algorithm.

  If the default provider package provides an implementation of the requested key management algorithm, an instance of `KeyManagerFactory` containing that implementation is returned. If the algorithm is not available in the default provider package, other provider packages are searched.

  Parameters:
    `algorithm` - the standard name of the requested algorithm.
  Returns:
    the new `KeyManagerFactory` object
  Throws:
    `NoSuchAlgorithmException` - if the specified algorithm is not available in the default provider package or any of the other provider packages that were searched.

### getInstance

    public static final KeyManagerFactory getInstance(String algorithm,
                                                      String provider)
                                               throws NoSuchAlgorithmException,
                                                      NoSuchProviderException

  Generates a `KeyManagerFactory` object for the specified key management algorithm from the specified provider.

  Parameters:
    `algorithm` - the standard name of the requested algorithm.
    `provider` - the name of the provider
  Returns:
    the new `KeyManagerFactory` object
  Throws:
    `NoSuchAlgorithmException` - if the specified algorithm is not available from the specified provider.
    `NoSuchProviderException` - if the specified provider has not been configured.
    `IllegalArgumentException` - if the provider name is null or empty.

### getInstance

    public static final KeyManagerFactory getInstance(String algorithm,
                                                      Provider provider)
                                               throws NoSuchAlgorithmException

  Generates a `KeyManagerFactory` object for the specified key management algorithm from the specified provider.

  Parameters:
    `algorithm` - the standard name of the requested algorithm.
    `provider` - an instance of the provider
  Returns:
    the new `KeyManagerFactory` object
  Throws:
    `NoSuchAlgorithmException` - if the specified algorithm is not available from the specified provider.
    `IllegalArgumentException` - if provider is null.

### getProvider

    public final Provider getProvider()

  Returns the provider of this `KeyManagerFactory` object.

  Returns:
    the provider of this `KeyManagerFactory` object

### init

    public final void init(KeyStore ks,
                           char[] password)
                    throws KeyStoreException,
                           NoSuchAlgorithmException,
                           UnrecoverableKeyException

  Initializes this factory with a source of key material.

  The provider typically uses a KeyStore for obtaining key material for use during secure socket negotiations. The KeyStore is generally password-protected.

  For more flexible initialization, please see `init(ManagerFactoryParameters)`.

  Parameters:
    `ks` - the key store or null
    `password` - the password for recovering keys in the KeyStore
  Throws:
    `KeyStoreException` - if this operation fails
    `NoSuchAlgorithmException` - if the specified algorithm is not available from the specified provider.
    `UnrecoverableKeyException` - if the key cannot be recovered (e.g. the given password is wrong).

### init

    public final void init(ManagerFactoryParameters spec)
                    throws InvalidAlgorithmParameterException

  Initializes this factory with a source of provider-specific key material.

  In some cases, initialization parameters other than a keystore and password may be needed by a provider. Users of that particular provider are expected to pass an implementation of the appropriate `ManagerFactoryParameters` as defined by the provider. The provider can then call the specified methods in the `ManagerFactoryParameters` implementation to obtain the needed information.

  Parameters:
    `spec` - an implementation of a provider-specific parameter specification
  Throws:
    `InvalidAlgorithmParameterException` - if an error is encountered

### getKeyManagers

    public final KeyManager[] getKeyManagers()

  Returns one key manager for each type of key material.

  Returns:
    the key managers

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.